(function(){

//---------------CONFIG---------------------

const NAME = 'SoftwareTranslatorForWeb';

const SHORT_NAME = 'S';

const IMPROVE_NATIVES = true;

//---------------CONFIG-END-----------------



const G =
{
    WINDOW: window
,
    A: Array.slice
,
    each: Array.forEach
};

function getSelf(){ return this; }

G.__name__ = NAME;
G.__defineGetter__(NAME, getSelf);
G.__defineGetter__(SHORT_NAME, getSelf);

window[NAME] = G;

function addFunctions(target, arr)
{
    if (!arr) {
        arr = target;
        target = this;
    }
    for (var i = 0, n = arr.length; i < n; ++i)
        target[arr[i].name] = arr[i];
    return target;
}


function __procFunctions(proc, dst, src)
{
    if (G.isArray(src))
        for (var i = 0, n = src.length; i < n; ++i)
            proc(dst, src[i].name, src[i]);
    else
        for (var i in src)
            proc(dst, src[i].name, src[i]);
}


const FEO = {prototype: null, parent: null};
const PEO = Object.prototype;


with (G) {

addFunctions(G,
[
    function HASH ()
    {
        return {__proto__: null};
    }
,
    function __new(T, args)
    {
        var obj = {__proto__: T.prototype};
        if (args) T.apply(obj, args);
        return obj;
    }
,
    function K (arg) { return arg; }
,
    function iter(obj, fun, thisp)
    {
        for (var k in obj)
            fun.call(thisp, k, obj[k], obj);
        return thisp;
    }
,
    function isString (x)
    {
        return typeof x == 'string';
    }
,
    function isArray(x)
    {
        //we have to compare constructor names, because different windows has different Array
        return x && x.constructor.name == Array.name;
    }
,
    function isObject (x)
    {
        return typeof x == 'object';
    }
,
    function isFunction (x)
    {
        return typeof x == 'function';
    }
,
    function isNumber (x)
    {
        return typeof x == 'number';
    }
,
    function isUndefined (object)
    {
        return typeof object == "undefined";
    }
,
    function isPrototype (x)
    {
        return x && x.constructor && x.constructor.prototype === x;
    }
,
    function inherit (x, base)
    {
        x.prototype.__proto__ = base.prototype;
        x.__proto__ = base;
    }
,   
    function bind (target, fn, name)
    {
        return eval('(function '+(name||fn.name)+'(){return fn.apply(target, arguments);})');
    }
,
    function generic (fn, name)
    {
        switch (typeof fn) {
        case 'function':
            return eval('(function '+(name||fn.name)+'(){return fn.apply(arguments[0], A(arguments, 1));})');
        case 'string':
            return eval('(function '+(name||fn)+'(){return this.prototype.'+fn+'.apply(arguments[0], A(arguments, 1));})');
        default:
            throw new TypeError();
        }
    }
,
    function _extend (dst, src, exclude)
    {
        for (var i in src) {
            if ( exclude && i in exclude )
                continue;
                
            var g = src.__lookupGetter__(i);
            var s = src.__lookupSetter__(i);
            
            if (g || s)
            {
                if (g) dst.__defineGetter__(i, g);
                if (s) dst.__defineSetter__(i, s);
            }
            else
                dst[i] = src[i];
        }
    }
,
    function _mixin (dst, src)
    {
        if (typeof dst != 'function')
            throw new TypeError();
            
        if (typeof src == 'function') {
            _extend(dst, src, FEO);
            _extend(dst.prototype, src.prototype, PEO);
        } else {
            _extend(dst.prototype, src, PEO);
        }
    }
,
    function _provide (dst, src)
    {
        _extend(dst, src, dst);
    }
,
    function __defineMethod(dst, name, fn)
    {
        fn.parent = dst.__proto__[name];
        dst[name] = fn;
    }
,    
    function __defineGenericMethod(dst, name, fn)
    {
        __defineMethod(dst.prototype, name, fn);
        dst[name] = generic(fn, name);
    }
,
    function __defineGetter(dst, name, fn)
    {
        fn.parent = dst.__proto__.__lookupGetter__(name);
        dst.__defineGetter__(name, fn);
        if (!dst.__lookupSetter__(name)) {
            fn = dst.__proto__.__lookupSetter__(name);
            if (fn) dst.__defineGetter__(name, fn);
        }
    }
,
    function __defineSetter(dst, name, fn)
    {
        fn.parent = dst.__proto__.__lookupSetter__(name);
        dst.__defineSetter__(name, fn);
        if (!dst.__lookupGetter__(name)) {
            fn = dst.__proto__.__lookupGetter__(name);
            if (fn) dst.__defineGetter__(name, fn);
        }
    }
,
    function defineMethods (T, arr)
    {
        __procFunctions(__defineMethod, T.prototype, arr);
        return T;
    }
,
    function defineClassMethods (T, arr)
    {
        __procFunctions(__defineMethod, T, arr);
        return T;
    }
,

    function defineGenerics (T, arr)
    {
        __procFunctions(__defineGenericMethod, T, arr);
        return T;
    }
,
    function defineToClass(T, arr, from)
    {
        const base = T.__proto__;
        const prototype = T.prototype;
        const basePrototpe = base.prototype;
        
        var x, t, type = null, name = null;
        
        for (var i = from||0, n = arr.length; i < n; ++i)
        {   
            x = arr[i];
            switch (typeof x) {
            case 'string':
                t = x.split(/\s+/).filter(K);
                type = t[0];
                name = t[1];
                break;
            case 'function':
                name = name || x.name;
                switch (type) {
                case null:
                case 'method':
                    __defineMethod(prototype, name, x);
                    break;
                case 'classmethod':
                case 'classMethod':
                    __defineMethod(T, name, x);
                    break;
                case 'generic':
                case 'genericmethod':
                case 'genericMethod':
                    __defineGenericMethod(T, name, x);
                    break;
                case 'get':
                case 'getter':
                    __defineGetter(prototype, name, x);
                    break;
                case 'set':
                case 'setter':
                    __defineSetter(prototype, name, x);
                    break;
                case 'classgetter':
                case 'classGetter':
                    __defineGetter(T, name, x);
                    break;
                case 'classsetter':
                case 'classSetter':
                    __defineSetter(T, name, x);
                    break;
                default:
                    throw new Error('"'+(T.name)+'" class definition: invalid method modifier "'+type+'"');
                }
                type = null;
                name = null;
                break;
            default:
                throw new TypeError('"'+(T.name)+'" class definition: invalid method['+i+']');
            }
        }
            
        return T;
    }
,
    function Module (name)
    {
        if (name) {
            this.__name__ = name;
            this.__defineGetter__(name, getSelf);
        }
    }
]);


iter({
        extend : _extend,
        provide: _provide,
        mixin  : _mixin
    },
    function(name, fun) {
        G[name] = function() {
            var n = arguments.length;
            if (n < 2) {
                fun(this, arguments[0]);
                return this;
            }
            var dst = arguments[0];    
            for (var i = 1; i < n; ++i)
                fun(dst, arguments[i]);
            return dst;
        };
    }
);


Module.prototype.__defineGetter__('self', getSelf);
Module.prototype.__defineGetter__('parent', function()
{
    return arguments.callee.caller.parent;
});


addFunctions(Module.prototype,
[
    addFunctions
,
    function newModule (name)
    {
        var module = new Module(name);
        if (name) this[name] = module;
        return module;
    }
,
    function extended () {
        var i = 0, n = arguments.length;
        var obj = {__proto__: (n < 2) ? this : arguments[i++]};
        for (; i < n; ++i)
            _extend(obj, arguments[i]);
        return obj;
    }
,
    function newClass (/*name, base, mixins..., [constructor, ...] */)
    {
        const argv = arguments;
        var i = 0, argc = arguments.length;
        
        var name = i < argc && isString(argv[i]) ? argv[i++] : '';
        
        var list = i < argc && isArray(argv[argc-1]) ? argv[--argc] : null;
        
        var base = i < argc && (argv[i] === null || isFunction(argv[i])) ? argv[i++] : null;
        
        var klass, n = argc - 1, from = 0;
        if (list && name && isFunction(list[0]) && list[0].name == name)
        {
            klass = list[0];
            klass.parent = base;
            from = 1;
        }
        else if (n < argc && isObject(argv[n]) && argv[n].hasOwnProperty('constructor'))
        {
            klass = argv[n].constructor;
            if (name && name != klass.name)
                throw new Error();
        }
        else
        {
            klass = base ?
                eval('(function '+name+'(){arguments.callee.__proto__.apply(this, arguments);})') :
                eval('(function '+name+'(){})');
        }
        
        if (base)
            inherit(klass, base);
        
        for (; i < argc; ++i)
            _mixin(klass, argv[i]);
            
        if (list)
            defineToClass(klass, list, from);
        
        klass.prototype.constructor = klass;
            
        if (name)
            this[name] = klass;
            
        return klass;
    }
]);




// make G an Module instance
G.__proto__ = Module.prototype;

G.__name__ = NAME;



addFunctions
([
    function _String(){},
    function _Array(){},
    
    function improveNative()
    {
        for (var i = 0; i < arguments.length; ++i)
        {
            var dst = arguments[i];
            var src = this['_' + dst.name];
            if (src) {
                _provide(dst, src);
                _provide(dst.prototype, src.prototype)
            }
        }
    }
]);


defineGenerics(_String,
[
    function toCapitalCase ()
    {
        return this[0].toUpperCase() + this.substring(1).toLowerCase();
    }
,    
    function toSameCaseAs (s)
    {
        if (s == s.toLowerCase()) return this.toLowerCase();
        if (s == s.toCapitalCase()) return this.toCapitalCase();
        if (s == s.toUpperCase()) return this.toUpperCase();
        return this.substring(0);
    }
,    
    function strip ()
    {
        return this.replace(/^\s+/, '')
                   .replace(/\s+$/, '');
    }
,    
    function endswith (str)
    {
        return this.substr(str.length *(-1)) == str;
    }
,
    function startswith (str)
    {
        return this.substr(0, str.length) == str;
    }
,
    function splitlines ()
    {
        return this.split(/\r\n|\n|\r/);
    }
]);

defineGenerics(_Array,
[
    function pluck (property)
    {
        var n = this.length, rv = new Array(n);
        for (var i = 0; i < n; ++i)
            rv[i] = this[i][property];
        return rv;
    }
,
    function invoke (method)
    {
        var args = A(arguments, 1);
        for (var i = 0, n = this.length; i < n; ++i)
            this[i][method].apply(this[i], args);
    }
,
    function contains (obj)
    {
        return this.indexOf(obj) != -1;
    }
,
    function remove (obj)
    {
        var index = this.indexOf(obj);
        if (index == -1) return false;
        this.splice(index, 1);
        return true;
    }
,
    function removeAll (obj)
    {
        var index, counter = 0;
        while ((index = this.indexOf(obj)) != -1) {
            this.splice(index, 1);
            ++counter;
        }
        return counter;
    }
]);

    
if (IMPROVE_NATIVES)
    improveNative(String, Array);

}})();
