(function(){with(SoftwareTranslatorForWeb){
const S = self;

S.ID = "SoftwareTranslatorForWeb@eurocitysoftware";

S.TITLE = "Software Translator For Web";

const $ = dom.$;

const ELEMENT_ATTRIBUTES =
{
    'src': 1,
    'value': 1,
    'title': 1,
    'alt': 1
};

S.XUL = new XULTagBuilder();


var mEnabled, mInitialized, mPrefs, mEditorIsVisible;
var mCurrentDictionary, mCurrentDictionaryView;
var mLocationWatcher, mCurrentHost, mTabSelectTimeout;

var mFilePath2Index = HASH();
var mFilePath2View = HASH();


var $appcontent, $tabBrowser, $contentSplitter, $contentBox, $deck;
var $fileMenuButton, $editorButtons, $selectTextToolButton, $filter, $filterClearButton, $checkDictionaryButton;

var $saveMenuitem, $saveAsMenuitem;

var $saveNowButton;

var host2filePath = {};

extend
({
    get enabled ()
    {
         return mEnabled;
    }
,
    set enabled (value)
    {
        mEnabled = value;
        if (mEnabled) {
            try {
                SAASTranslator.enabled = false;
            } catch (e) {}
        }
        this.showEditir(mEnabled);
        this.syncContent();
    }
,
    get filter ()
    {
        return $filter.value;
    }
,
    set filter (val)
    {
        val = val || '';
        mCurrentDictionaryView.filter = val;
        $filter.value = val;
        $filterClearButton.setAttribute('disabled', !val);
    }
,
    _handlers: {}
,
    prompts: Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService)
});       
        

addFunctions
([
    function H (name)
    {
        if (!(name in this._handlers))
            this._handlers[name] = bind(this, this[name]);
        return this._handlers[name];
    }
,
    function dump (msg)
    {
        this.forcedDump('STFW: '+msg);
    }
,
    function alert (msg)
    {
        prompts.alert(null, TITLE, msg);
    }
,
    function confirm (msg)
    {
        return prompts.confirm(null, TITLE, msg);
    }
,
    function confirmSave (msg, checkMsg, check)
    {
        return !prompts.confirmEx(null, TITLE, msg,
            prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_SAVE +
            prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_CANCEL,
            '', '', '', checkMsg||null, check||{});
    }
,
    function confirmSave2 (msg, checkMsg, check)
    {
        var flags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_SAVE +
                    prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_DONT_SAVE ;
                    //prompts.BUTTON_POS_2 * prompts.BUTTON_TITLE_CANCEL;
        return prompts.confirmEx(null, TITLE, msg, flags, '', '', '',
                checkMsg||null, check||{});
    }
,
    function initialize()
    {
        if (mInitialized)
            return;
            
        $tabBrowser = $('content');  
        $appcontent = $('appcontent');                
        $contentSplitter = $('SoftwareTranslatorForWeb-contentSplitter');        
        $contentBox = $('SoftwareTranslatorForWeb-contentBox');          
        $deck = $('SoftwareTranslatorForWeb-deck');
        $fileMenuButton = $('SoftwareTranslatorForWeb-fileMenuButton');
        $editorButtons = $('SoftwareTranslatorForWeb-editorButtons');
        $selectTextToolButton = $('SoftwareTranslatorForWeb-selectTextToolButton');
        $filter = $('SoftwareTranslatorForWeb-filter');
        $filterClearButton = $('SoftwareTranslatorForWeb-filterClearButton');
        $saveNowButton = $('SoftwareTranslatorForWeb-saveNowButton');
        $saveMenuitem = $('SoftwareTranslatorForWeb-saveMenuitem');
        $saveAsMenuitem = $('SoftwareTranslatorForWeb-saveAsMenuitem');
        $checkDictionaryButton = $('SoftwareTranslatorForWeb-checkDictionaryButton');
        
        this.initializeCommons();

        mLocationWatcher = new LocationWatcher();
        mLocationWatcher.addListiner(H('onLocationChange'));
        mLocationWatcher.register($tabBrowser);

        $tabBrowser.addEventListener("DOMContentLoaded", H('onDOMContentLoaded'), true);
//         $tabBrowser.addEventListener("DOMFrameContentLoaded", H('onDOMContentLoaded'), true);
        
        $tabBrowser.addEventListener('TabSelect', H('onTabSelect'), false);
        
        $filter.addEventListener('keypress', H('onFilterKeyPress'), false);
        
        mInitialized = true;
    }
,
    function close ()
    {
        return this.askToSaveUnsaved();
    }
,
    function unload ()
    {
        mLocationWatcher.unregister($tabBrowser);
    }
,
    function initializeCommons ()
    {
        var hw = getHiddenWindow();
        this.com = hw[ID];
        if (this.com) return;
        this.com = hw[ID] = {
            filePath2dict: {}
        }
    }
,
    function isContentLoaded ()
    {
        return content.document.SoftwareTranslatorForWeb_DOMContentLoaded;
    }
,
    function saveAllDictionaries (forced)
    {
        for each (var dict in com.filePath2dict)
            this.saveDictionary(dict, null, forced);
    }
,
    function askToSaveUnsaved ()
    {
        var unsaved = [];
        for each (var dict in com.filePath2dict)
            if (dict.changed)
                unsaved.push(dict);
        var button, check = {value: false};
        var n = unsaved.length;
        while (n--) {
            var dict = unsaved[n];
            if (!check.value)
                button = confirmSave2('Do you want to save the changes to '+(localFile(dict.src).leafName)+'?',
                             (n > 1 ? 'same for other '+n+' files!' : null),
                             check);
            switch (button) {
            case 0:
                saveDictionary(dict, null, true);
                break;
            case 1:
                break;
            case 2:
                return false;
            }
        }
        return true;
    }
,
    function saveDictionary (dict, file, forced)
    {
        if (!forced && !dict.changed && (!file || file.path == dict.src)) return;
        file = file || localFile(dict.src);
        var data, ext = fileExtension(file).toLowerCase();
        switch (ext) {
        case '.xml':
            data = dict.toXML();
            break;
        case '.txt':
            data = dict.toText();
            break;
        default:
            data = dict.toText();
        }
        try {
            writeFile(file, data);
            dict.savedToFile(file);
            return true;
        } catch (e) {
            alert('Error on saving "'+(file.path)+'".\n\n'+e);
            return false;
        }
    }
,
    function saveCurrentDictionaryAs (file, asCopy)
    {
        const dict = mCurrentDictionary;
        const oldPath = dict.src;
        file = file || this._pickFileToSave('Save As', localFile(oldPath).location);
        if (file && this.saveDictionary(dict, file, true) && !asCopy) {
            dict.savedToFile(file);
            mFilePath2Index[file.path] = mFilePath2Index[oldPath];
            delete mFilePath2Index[oldPath];
            com.filePath2dict[file.path] = dict;
            delete com.filePath2dict[oldPath];
            host2filePath[mCurrentHost] = file.path;
            this.syncDictionary();
        }
    }
,
    function saveCurrentDictionary (forced)
    {
        if (mCurrentDictionary)
            return this.saveDictionary(mCurrentDictionary, null, forced);
        return false;
    }
,
    function onSaveNow (event)
    {
        $saveNowButton.setAttribute('disabled', true);
        var deflabel = $saveNowButton.label;
        $saveNowButton.label = 'Saving...';
        var delay = 0, done = false;
        if (!event.shiftKey)
            done = this.saveCurrentDictionary(true);
        else {
            this.saveAllDictionaries(false);
            done = true;
        }
        if (done) {
            $saveNowButton.label = 'Done!';
            delay = 1000;
        }
        setTimeout(function(){
            $saveNowButton.label = deflabel;
            $saveNowButton.setAttribute('disabled', false);
        }, delay);
    }            
,
    function onMenuShowing (menu)
    {
        $saveMenuitem.setAttribute('disabled', !mCurrentDictionary);
        $saveAsMenuitem.setAttribute('disabled', !mCurrentDictionary);
    }
,
    function onTabSelect (event)
    {
         clearTimeout(mTabSelectTimeout);
         mTabSelectTimeout = setTimeout(H('_onTabSelect'), 200);
    }
,
    function _onTabSelect (event)
    {
        this.syncSelectTextTool();
        this.syncContent();
    }
,
    function onDOMContentLoaded (event)
    {
//         setTimeout(function(){
            var doc = event.originalTarget;
            if (doc
             && doc.nodeName == '#document'
             && !doc[ID]
             && doc instanceof HTMLDocument
             && doc.location && doc.location != 'about:blank'
             && doc.designMode == 'off'
             && !isSystemDocument(doc)
            ) {
                doc[ID] = {};
                doc.addEventListener('DOMNodeInserted', H('onDOMChange'), true);
//                 doc.addEventListener('DOMAttrModified', H('onDOMChange'), true);
//                 doc.addEventListener('DOMCharacterDataModified', H('onDOMChange'), true);
                
                if (mEnabled
//                  && doc.location.host == mCurrentHost
                 && isCurrentDocument(doc, true)
                ) {
                    this.syncContent(doc, false);
                }
            }
//         });
    }
,
    function onDOMChange (event)
    {
        if (!mEnabled || !mCurrentDictionary) return;
        var node = event.target;
        var doc = node.ownerDocument;
        var d = doc[ID];
        if (!d) return;
        if (!d.processing && doc.location.host == mCurrentHost) {
            d.processing = true;
            //mCurrentDictionary._views.invoke('dontSort');
            if (node.nodeType != node.ELEMENT_NODE || node.nodeName == 'INPUT')
                this.performSingleTranslation(node);
            else
                this.performTranslation(node);
            d.processing = false;
        }
    }        
,
    function isCurrentDocument (doc, deep)
    {
        if (!content || !content.document || !doc)
            return false;
        
        if (doc === content.document)
            return true;
            
        if (deep && isSubDocument(content.document, doc, true))
            return true;
        
        return false;
    }
,
    function isSubDocument (node, doc, deep)
    {
        var docs = dom.getSubDocuments(node);
        if (docs.contains(doc))
            return true;
        
        if (deep) {
            for (var i = 0; i < docs.length; ++i) {
                if (isSubDocument(docs[i], doc, deep))
                    return true;
            }
        }
        
        return false;
    }
,
    function onLocationChange (win, uri)
    {
        var host = this.getCurrentHostname();
        if (mCurrentHost == host) return;
        mCurrentHost = host;
        this.syncDictionary();
    }
,
    function getCurrentHostname ()
    {
        try {
            return content.location.hostname;
        } catch (er) {
            return null;
        }
    }
,
    function showEditir (show)
    {
        $contentSplitter.setAttribute("collapsed", !show);
        $contentBox.setAttribute("collapsed", !show);
        mEditorIsVisible = show;
        if (show) this.syncEditor();
        else this.enableSelectTextToTranslate(false);
    }
,
    function onStatusMouseDown (event)
    {
        if (event.button == 2 && event.shiftKey && event.altKey && (event.ctrlKey || event.metaKey)) {
//             dom.appendClassTreeList(Base, content.document);
            evalFocusedElementValue();
            return;
        }
        this.enabled = !this.enabled;
    }
,
    function onFilterKeyPress (event)
    {
        switch (event.keyCode){
            case event.DOM_VK_ESCAPE:
                this.filter = '';
                break;
            case event.DOM_VK_RETURN:
                this.filter = event.target.value;
                break;
        }
    }
,
    function _pickFileToSave (title, folder)
    {
        title = title || 'Save As';
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"]
                           .createInstance(nsIFilePicker);
        fp.init(window, title, nsIFilePicker.modeSave);
        fp.appendFilters(nsIFilePicker.filterXML);
        fp.appendFilters(nsIFilePicker.filterText);
        fp.appendFilters(nsIFilePicker.filterAll);
        if (folder) fp.displayDirectory = folder;
        
        var rv = fp.show();
        if (rv == nsIFilePicker.returnOK || rv == nsIFilePicker.returnReplace) {
//             var ext;
//             switch (fp.filterIndex) {
//                 case nsIFilePicker.filterXML:
//                     ext = '.xml';
//                     break;
//                 case nsIFilePicker.filterText:
//                     ext = '.txt';
//                     break;
//             }
//             if (ext && !(fp.file.path.toLowerCase().endswith(ext)))
//                 return localFile(fp.file.path + ext);
            return fp.file;
        }
        return null;
    }
,
    function _pickFileToOpen (title, folder)
    {
        title = title || 'Open';
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"]
                           .createInstance(nsIFilePicker);
        fp.init(window, title, nsIFilePicker.modeOpen);
        fp.appendFilters(nsIFilePicker.filterAll);
        fp.appendFilters(nsIFilePicker.filterXML);
        fp.appendFilters(nsIFilePicker.filterText);
        if (folder) fp.displayDirectory = folder;
        
        if (fp.show() == nsIFilePicker.returnOK)
            return fp.file;
        else
            return null;
    }
,
    function pickDictionaryFile ()
    {
        //this.saveCurrentDictionary();
        var file = this._pickFileToOpen('Open Dictionary');
        if (file) this.loadDictionaryFile(file);
    }
,
    function pickNewDictionaryFile ()
    {
        //this.saveCurrentDictionary();
        var file = this._pickFileToSave('New Dictionary');
        if (file && this.saveDictionary(new Dictionary, file))
            this.loadDictionaryFile(file);
    }
,
    function _loadDictionaryFile (file, safe)
    {
        var host = getCurrentHostname();
        var dict = com.filePath2dict[file.path];
        if (!dict || !dict.srcLastModifiedTime || (file.exists && dict.srcLastModifiedTime < file.lastModifiedTime)) {
            try {
                var data = readFile(file);
                if (data === null)
                    throw new DictionaryError('unable to open "'+(file.path)+'"');
                var ext = splitext(file.path)[1].toLowerCase();
                switch (ext) {
                    case '.xml':
                        dict = Dictionary.fromXML(data);
                        break;
                    case '.txt':
                        dict = Dictionary.fromText(data);
                        break;
                    default:
                        dict = Dictionary.from(data);
                }                    
            } catch (e) {
                if (safe) {
                    delete host2filePath[host];
                    return null;
                }
                throw e;
            }
            dict.savedToFile(file);
            com.filePath2dict[file.path] = dict;
        }
        host2filePath[host] = file.path;
        return dict;
    }
,
    function loadDictionaryFile (file)
    {
        try {
            var dict = this._loadDictionaryFile(file);
            this.syncDictionary();
            this.checkDefinitions(dict);
            return dict;
        } catch (e) {
            if (e instanceof DictionaryError)
                alert(e.message);
            else
                throw e;
        }
    }
,
    function onCheckDefinitionButton (event)
    {
        if (!mCurrentDictionary) return;
        var deflabel = $checkDictionaryButton.label;
        $checkDictionaryButton.setAttribute('disabled', true);
        var n = checkDefinitions(mCurrentDictionary);
        var delay = 0;
        if (n == 0) {
            $checkDictionaryButton.label = 'OK!';
            delay = 1000;
        }
        setTimeout(function(){
            $checkDictionaryButton.label = deflabel;
            $checkDictionaryButton.setAttribute('disabled', false);
        }, delay);
    }
,
    function checkDefinitions (dict)
    {
        var n = 0;
        var map = dict._map;
        for (var key in map)
            if (!map[key].isValid)
                n++;
        if (n > 0)
            alert('There are '+n+' invalid definitions!\n\nScroll definition list to locate red cells.');
        return n;
    }
,
    function syncDictionary ()
    {
        var host = getCurrentHostname();
        var filePath = host2filePath[host];
        if (filePath) {
            mCurrentDictionary = com.filePath2dict[filePath]
                    || _loadDictionaryFile(localFile(filePath), true);
        }
        else {
            mCurrentDictionary = null;
        }
        this.syncContent();
        if (mEditorIsVisible)
            this.syncEditor();
    }
,
    function syncContent (doc, deep)
    {
        if (doc === undefined)
            doc = content.document;
        if (deep === undefined)
            deep = true;
        if (!(doc instanceof Document)) return;
        var d = doc[ID];
        if (d && !d.processing) {
           d.processing = true;
            try {
                var dict = mCurrentDictionary;
                if (mEnabled && dict) {
                    if (d.dictionary !== dict || d.revision < dict.revision) {
                        d.dictionary = dict;
                        d.revision = dict.revision;
                        this.performTranslation(doc, dict);
                    }
                } else {
                    if (d.dictionary) {
                        d.dictionary = null;
                        this.restoreOriginal(doc);
                    }
                }
            } finally {
                d.processing = false;
            }
        }
        if (deep) S.dom.iterateWindows(doc, function(win) {
            this.syncContent(win.document, false);
        }, this);
    }              
,
    function syncEditor ()
    {
        var dict = mCurrentDictionary;
        var index = 0;
        $fileMenuButton.label = 'File';
        $editorButtons.setAttribute("collapsed", !dict);
        if (dict) {
            index = mFilePath2Index[dict.src];
            $fileMenuButton.label = localFile(dict.src).leafName;
            if (!index) {
                with (XUL) {
                    var box = BOX({class:'SoftwareTranslatorForWeb-dictionary'});
                    index = $deck.childNodes.length;
                    $deck.appendChild(box);
                    box.tree.dictionary = dict;
                    mFilePath2Index[dict.src] = index;
                    mFilePath2View[dict.src] = new DictionaryTreeView(dict, box.tree);
                }
            }
        }
        mCurrentDictionaryView = dict ? mFilePath2View[dict.src] : null;
        if ($deck.selectedIndex != index) {
            $deck.selectedIndex = index;
            if (dict) this.syncFilter();
        }
    }
,
    function syncFilter ()
    {
        this.filter = mCurrentDictionaryView ?
            mCurrentDictionaryView.filter : null;
    } 
,
    function getNodes (root)
    {
        root = root || content.document;
        var escludedTags = dom.INVISIBLE_TAGS;
        var result = dom.evaluate('.//input|.//img', root);
        dom.evaluate('.//text()', root, function(t) {
            if (/\S/.test(t.data) && !(t.parentNode.nodeName in escludedTags))
                result.push(t);
        });
        return result;
    }
,
    function _performSingleTranslation (node, dict)
    {
        var orig = node._SoftwareTranslatorForWeb_original;
        if (orig === undefined) {
            orig = this.getNodeValue(node);
        }
        if (!orig) return;
        if (orig.constructor === Object) {
            var res = {};
            for (var name in orig)
                res[name] = dict.translate(orig[name]);
        } else {
            var res = dict.translate(orig);
        }
        if (res !== null) {
            this.setNodeValue(node, res);
            node._SoftwareTranslatorForWeb_original = orig;
        } else if (orig !== undefined) {
            this.setNodeValue(node, orig);
            node._SoftwareTranslatorForWeb_original = undefined;
        }
    }
,
    function performSingleTranslation (node, dict)
    {
        dict = dict || mCurrentDictionary;
        if (!dict) return null;
        this._performSingleTranslation(node, dict);
    }
,
    function performTranslation (doc, dict)
    {
        dict = dict || mCurrentDictionary;
        if (!dict) return null;
        dict.withNoTreeUpdates(function(){
            var nodes = this.getNodes(doc);
            for (var i = 0, n = nodes.length; i < n; ++i)
                this._performSingleTranslation(nodes[i], dict);
        }, this);
    }
,
    function restoreOriginal (doc)
    {
        this.getNodes(doc).forEach(function(node) {
            var orig = node._SoftwareTranslatorForWeb_original;
            if (orig !== undefined) {
                node._SoftwareTranslatorForWeb_original = undefined;
                this.setNodeValue(node, orig);
            }
        }, this);
    }
,
    function openDefinitionEditor (dict, def, index)
    {
        window.openDialog('chrome://SoftwareTranslatorForWeb/content/defEditor.xul',
            'SoftwareTranslatorForWeb_DefinitionEditor',
            'chrome,titlebar,toolbar,centerscreen,modal,dependent',
            dict||mCurrentDictionary, def, index);
    }
,
    function getCurrentTree ()
    {
        var node = $deck.childNodes[$deck.selectedIndex];
        return node.tree;
    }
,
    function onAddDefinitionButton (event)
    {
        var tree = this.getCurrentTree();
        if (!tree) return;
        var dict = tree.dictionary;
        var index = tree.currentIndex;
        var def = (index != -1 ? mCurrentDictionaryView._list[index] : null);
        this.openDefinitionEditor(dict, def);
    }
,
    function getTreeSelectionRanges (tree)
    {
        var first = {}, last = {}, rv = [];
        var sel = tree.view.selection;
        for (var i = 0, n = sel.getRangeCount(); i < n; i++) {
            sel.getRangeAt(i, first, last);
            rv.push([first.value, last.value+1]);
        }
        return rv;
    }
,
    function onRemoveDefinitionsButton (event)
    {
        var tree = this.getCurrentTree();
        if (!tree) return;
        var dict = tree.dictionary;
        var view = tree._STFW_view;
        var viewList = view._list;
        var dictMap = dict._map;
        var ranges = getTreeSelectionRanges(tree);
        ranges.reverse();
        ranges.forEach(function(r) {
            var n = r[1] - r[0];
            var rm = viewList.splice(r[0], n);
            for (var i = 0; i < n; ++i)
                delete dictMap[rm[i].source];
            view._treeBox.rowCountChanged(r[0], -n);
        });
        dict._revision++;
        this.syncContent();
    }
,
    function onClearFilter (event)
    {
        this.enableSelectTextToTranslate(false);
        this.filter = '';
    }
,
    function syncSelectTextTool ()
    {
        var s = content.SoftwareTranslatorForWeb_SelectTextTool;
        this.enableSelectTextToTranslate((s && s.running));
    }
,
    function toggleSelectTextTool ()
    {
        var s = content.SoftwareTranslatorForWeb_SelectTextTool;
        this.enableSelectTextToTranslate(!(s && s.running));
    }
,
    function setFilter (value, showEditorIfNoMatch)
    {
        this.filter = value;
        if (mCurrentDictionaryView._list.length == 0)
        {
            if (showEditorIfNoMatch)
                this.openDefinitionEditor(mCurrentDictionary);
        }
        else
        {
            var n = mCurrentDictionaryView.chackForPriorityConflictOfFiltered();
            if (n > 1)
                alert('There are '+n+' definitions with the same highest priority that match with the filter!');
        }
    }        
,
    function enableSelectTextToTranslate (enable)
    {
        enable = !!enable;
        var win = content;
        var s = win.SoftwareTranslatorForWeb_SelectTextTool;
        var enabled = s && s.running;
        if (enabled != enable) {
            if (enable) {
                if (!s) {
                    s = new SelectTextTool(win);
                    win.SoftwareTranslatorForWeb_SelectTextTool = s;
                }
                s.start();
            }
            else {
                if (s) s.stop();
            }
        }
        $selectTextToolButton.setAttribute('checked', enable);
    }
,
    function getNodeValue (node)
    {
        switch (node.nodeType) {
        case node.ATTRIBUTE_NODE:
        case node.CDATA_SECTION_NODE:
            return node.nodeValue;
        case node.TEXT_NODE:
            return dom.textNodeComputedValue(node);
        case node.ELEMENT_NODE:
            var rv = {};
            for (var attr in ELEMENT_ATTRIBUTES)
                if (isString(node[attr]))
                    rv[attr] = node[attr];                
            return rv;
        default:
            return null;
        }
    }
,
    function setNodeValue (node, value)
    {
        switch (node.nodeType) {
        case node.ATTRIBUTE_NODE:
        case node.CDATA_SECTION_NODE:
        case node.TEXT_NODE:
            node.nodeValue = value;
            break;
        case node.ELEMENT_NODE:
            for (var attr in value)
                if (isString(value[attr]))
                    node[attr] = value[attr];
        }
    }
,
    function isTopDocument (doc)
    {
        var n = gBrowser.browsers.length;
        while (n--) {
            if (doc === gBrowser.getBrowserAtIndex(n).contentDocument);
                return true;
        }
        return false;
    }
,
    function isSystemDocument (doc)
    {
        try
        {
            if (!doc)
                return false;
    
            // Detect network error pages like 404
            if (doc.documentURI.indexOf("about:neterror") == 0)
                return true;
            
            // Detect pages for pretty printed XML
            return (doc.styleSheets.length && doc.styleSheets[0].href
                    == "chrome://global/content/xml/XMLPrettyPrint.css")
                || (doc.styleSheets.length > 1 && doc.styleSheets[1].href
                    == "chrome://browser/skin/feeds/subscribe.css");
        }
        catch (exc)
        {
            // Sometimes documents just aren't ready to be manipulated here, but don't let that
            // gum up the works
            // ERROR(exc)
            return false;
        }
    }
]);


window.addEventListener("load", H('initialize'), false);
window.addEventListener("close", H('close'), false);
window.addEventListener("unload", H('unload'), false);

}})();
