(function(){with(SoftwareTranslatorForWeb){

const CI = Components.interfaces;
const STATE_START = CI.nsIWebProgressListener.STATE_START;
const STATE_STOP = CI.nsIWebProgressListener.STATE_STOP;

newClass('ProgressListiner',
[
    function QueryInterface (aIID)
    {
        if ( aIID.equals(CI.nsIWebProgressListener)
          || aIID.equals(CI.nsISupportsWeakReference)
          || aIID.equals(CI.nsISupports)
          ) return this;
        throw Components.results.NS_NOINTERFACE;
    }
,
    function onStateChange (aProgress, aRequest, aFlag, aStatus) {return 0;},
    function onLocationChange (aProgress, aRequest, aURI) {return 0;},
    function onProgressChange () {return 0;},
    function onStatusChange () {return 0;},
    function onSecurityChange () {return 0;},
    function onLinkIconAvailable () {return 0;}
]);


newClass('LocationWatcher',
[
    function LocationWatcher ()
    {
        this._lastURL = null;
        this._listiners = [];
        this._progressListiner = new ProgressListiner();
        this._progressListiner.onLocationChange = bind(this, this._onLocationChange);
    }
,
    function addListiner (listiner)
    {
        if (!this._listiners.contains(listiner));   
            this._listiners.push(listiner);
    }
,
    function removeListiner (listiner)
    {
        this._listiners.removeAll(listiner);
    }
,
    function invokeListiners ()
    {
        const f = this._listiners;
        for (var i = 0; i < f.length; ++i) {
            try {
                f[i].apply(null, arguments);
            } catch (e) {
                reportError(e);
            }
        }
    }
,
    function register (browser)
    {
        browser.addProgressListener(this._progressListiner, CI.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    }
,
    function unregister (browser)
    {
        browser.removeProgressListener(this._progressListiner, CI.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    }        
,
    function _onLocationChange (aProgress, aRequest, aURI)
    {
        if (this._lastURL !== null && aURI.spec == this._lastURL)
            return;
            
        this._lastURL = aURI.spec;
        var win = aProgress.DOMWindow;
        this.invokeListiners(win, aURI);
    } 
]);



}})();
