(function(){with(SoftwareTranslatorForWeb){

newClass('MyError',
[
    function MyError (msg, error)
    {
        this.message = msg;
        this.error = error;
//         reportError(this.toString() + '\n' + error);
    }
,
    function toString ()
    {
        if (this.message)
            return this.constructor.name + ': ' + this.message;
        else
            return this.constructor.name;
    }
]);

    
addFunctions
([
    function getCallers(n)
    {
        var res = [];
        var f = arguments.callee.caller;
        while (n--) {
            f = f.caller;
            if (!f) break;
            res.push(f);
        }
        return res;
    }
,
    function evalFocusedElementValue ()
    {
        var el = document.commandDispatcher.focusedElement;
        var code = el.value;
        if (!code) return;
        var ans = eval(code);
        if (ans !== undefined)
            forcedDump(ans);
    }
,
    function reportError (e)
    {
        Components.utils.reportError(e);
    }
,
    function forcedDump (msg)
    {
        Components.classes["@mozilla.org/consoleservice;1"]
            .getService(Components.interfaces.nsIConsoleService)
            .logStringMessage(msg);
    }
,
    function safeApply (f, thisArg, args)
    {            
        try {
            return f.apply(thisArg, args);
        } catch (e) {
            reportError(e);
        }
    }
,
    function safeCall (f, thisArg)
    {
        return safeApply(f, thisArg, Array.slice(arguments, 2));
    }      
,
    function concat ()
    {
        var len = 0, a = arguments, n = a.length;
        while (n--) len += a[n].length;
        var rv = new Array(len), pos = 0;
        for (var i=0, n=a.length; i < n; ++i)
            for (var j=0, m=a[i].length; j < m; ++j)
                rv[pos++] = a[i][j];
        return rv;
    }
,
    function extendArray(dst, src)
    {
        for (var i = 0, n = sr.length; i < n; ++i)
            dst.push(src[i]);
        return dst;
    }
,
    function keys (obj)
    {
        var rv = [];
        for (var key in obj)
            rv.push(key);
        return rv;
    }
,
    function keysWithValue (obj, val)
    {
        var rv = [];
        for (var key in obj)
            if (obj[key] === val)
                rv.push(key);
        return rv;
    }
,
    function abortEvent (event)
    {
        event.preventDefault();
        event.stopPropagation();
    }
,
    function getExtensionItem(id)
    {
        var em = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager);
        if (em.getItemForID)
            return em.getItemForID(id);
        else
            return em.getItemList(id, null, {})[0];
    }
,
    function getAppInfo()
    {
        return Components.classes["@mozilla.org/xre/app-info;1"]
                .getService(Components.interfaces.nsIXULAppInfo);
    }
,
    function url2uri (url)
    {
        return Components.classes["@mozilla.org/network/io-service;1"]
            .getService(Components.interfaces.nsIIOService)
            .newURI(url, null, null);
    }
,
    function path2url (path)
    {
        return 'file:///' + path.replace(/\\/g, '\/')
                                .replace(/^\s*\/?/, '')
                                .replace(/\ /g, '%20');
    }
,
    function openURL (url)
    {
        if (window.delayedOpenTab)
            window.delayedOpenTab(url)
        else
            Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
                .getService(Components.interfaces.nsIExternalProtocolService)
                .loadUrl(url2uri(url));
    }
,
    function getPrefBranch (root)
    {
        var rv = Components.classes["@mozilla.org/preferences-service;1"]
                        .getService(Components.interfaces.nsIPrefService)
                        .getBranch(root);
        rv.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
        return rv;
    }
,
    function getHiddenWindow ()
    {
        return Components.classes["@mozilla.org/appshell/appShellService;1"]
            .getService(Components.interfaces.nsIAppShellService)
            .hiddenDOMWindow;
    }
,
    function getExtensionFolder (id)
    {
        return Components.classes["@mozilla.org/extensions/manager;1"]
            .getService(Components.interfaces.nsIExtensionManager)
            .getInstallLocation(id)
            .getItemLocation(id);
    }
,
    function localFile (fileOrPath)
    {
        var file, n = arguments.length;
        
        if (typeof fileOrPath == 'string') {
            file = Components.classes['@mozilla.org/file/local;1']
                    .createInstance(Components.interfaces.nsILocalFile);
            try {
                file.initWithPath(fileOrPath);
            } catch(er) {
                if (n > 1) return arguments[n-1];
                else throw er;
            }       
        } else {
            file = fileOrPath.clone();
        }
        
        for (var i = 1; i < n && typeof arguments[i] == 'string'; ++i)  
            file.append(arguments[i]);
            
        return file;            
    }
,
    function readFile (file, charset)
    {
        if (charset === undefined) charset = 'UTF-8';
//         try {
            var data = new String();
            var fiStream = Components.classes['@mozilla.org/network/file-input-stream;1']
                            .createInstance(Components.interfaces.nsIFileInputStream);
            var siStream = Components.classes['@mozilla.org/scriptableinputstream;1']
                            .createInstance(Components.interfaces.nsIScriptableInputStream);
            fiStream.init(file, 1, 0, false);
            siStream.init(fiStream);
            data += siStream.read(-1);
            siStream.close();
            fiStream.close();
            if (charset) {
                data = toUnicode(charset, data);
            }
            return data;
//         }
//         catch(e) {
//             return null;
//         }
    }
,
    function writeFile (file, data, mode, charset)
    {
        if (charset === undefined) charset = 'UTF-8';        
//         try {
            var foStream = Components.classes['@mozilla.org/network/file-output-stream;1']
                            .createInstance(Components.interfaces.nsIFileOutputStream);
            if (charset) {
                data = fromUnicode(charset, data);
            }
            var flags = 0x02 | 0x08 | 0x20; // wronly | create | truncate
            if (mode == 'a') {
                flags = 0x02 | 0x10; // wronly | append
            }
            foStream.init(file, flags, 0664, 0);
            foStream.write(data, data.length);
//             foStream.flush();
            foStream.close();
//             return true;
//         }
//         catch(e) {
//             return false;
//         }
    }
,
    function toUnicode (charset, data)
    {
        try{
            var uniConv = Components.classes['@mozilla.org/intl/scriptableunicodeconverter']
                            .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
            uniConv.charset = charset;
            data = uniConv.ConvertToUnicode(data);
        } 
        catch(e) {
            // foobar!
        }
        return data;
    }
,
    function fromUnicode (charset, data)
    {
        try {
            var uniConv = Components.classes['@mozilla.org/intl/scriptableunicodeconverter']
                            .createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
            uniConv.charset = charset;
            data = uniConv.ConvertFromUnicode(data);
            // data += uniConv.Finish();
        }
        catch(e) {
            // foobar!
        }
        return data;
    }

,
    function listdir (dir)
    {
        if (dir.constructor === String)
            dir = localFile(dir);
        var entries = dir.directoryEntries;
        var array = [];
        while(entries.hasMoreElements())
            array.push(entries.getNext().QueryInterface(Components.interfaces.nsILocalFile));
        return array;
    }
,
    function splitext (path)
    {
        var pos = path.lastIndexOf('.');
        if (pos == -1) return [path, ''];
        return [path.substr(0, pos), path.substr(pos)];
    }
,
    function fileExtension (file)
    {
        var leaf = file.leafName;
        var pos = leaf.lastIndexOf('.');
        return (pos != -1) ? leaf.substring(pos) : '';
    }
,
    function getMimeType (mime)
    {
        return navigator.mimeTypes[mime];
    }
,
    function writeToClipboard (str)
    {
        if (!str) return;
        Components.classes["@mozilla.org/widget/clipboardhelper;1"]
        .getService(Components.interfaces.nsIClipboardHelper)
		.copyString(str);
	}
,
    function readFromClipboard()
    {
        var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
        if (!clip) return '';
        var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
        if (!trans) return '';
        trans.addDataFlavor("text/unicode");
        clip.getData(trans, clip.kGlobalClipboard);
        var str = new Object();
        var strLength = new Object(); 
        trans.getTransferData("text/unicode", str, strLength);
        if (str) str = str.value.QueryInterface(Components.interfaces.nsISupportsString);
        if (str) return str.data.substring(0, strLength.value / 2);
        return '';
    }
,
    function withHTTPRequest (url, fn, thisArg, req)
    {
        setTimeout(function(){
            if (req) req.abort();
            else req = new XMLHttpRequest();
            req.onreadystatechange = function(e){
                if (req.readyState != 4) return;
                var res = null;
                try {
                    if (req.status == 200)
                        res = req;
                } catch (er) {}
                fn.call(thisArg, res);
            };
            req.open("GET", url, true);
            req.setRequestHeader("Cache-Control", "no-cache");
            req.setRequestHeader("Pragma", "no-cache");
            req.send(null);
        });
    }   
,
    function retriveUrl (url, fn, thisArg, req)
    {
        if (req) req.abort();
        else req = new XMLHttpRequest();
        req.open("GET", url, false);
        req.setRequestHeader("Cache-Control", "no-cache");
        req.setRequestHeader("Pragma", "no-cache");
        req.send(null);
        var res = null;
        try {
            if (req.status == 0 || req.status == 200)
                res = req;
        } catch (er) {}
        return res;
    }
,
    function openPopupAtScreen (popup, x, y, isContextMenu)
    {
        if (popup.openPopupAtScreen) {
            popup.openPopupAtScreen(x, y, isContextMenu);
        } else {
            var doc = popup.ownerDocument;
            if (doc.popupNode !== null)
                doc.popupNode = popup;
            popup.popupBoxObject.showPopup(doc.documentElement, popup, x, y, 'popup', null, null);
            doc.popupNode = null;
        }
    }
]);

}})();
